<?php
// input:  id of batch

// MUST DEFINE PROJECTDIR

// MUST DEFINE CLOUD USER ID.  DEFAULT VALUE IS 1.

// example usage:
// http://abenaki.imag.fr/clouds_ops/assign_batch_to_cloud.php?batch=1


// After being called, all uncompleted workunits of batch will be assigned
// to cloud workers.  Script assumes all workunits of batch exist in db
// when being called.  Script only needs to be called once per batch.

//  It doesn't matter if cloud workers have started or not when the script is called.
// The assignment of workunits is to a user account, not a specific worker.
// So the workers just need to register under the CLOUD user id: 1.



// In particular,
// select all uncompleted workunits, and max result id in batch
// insert wu into assignment table.
// touch reread_db to force feeder to reload the shared
// memory segment

// www-data must have permissions to touch reread_db in the
// project directory. adduser www-data boincadm. doesn't
// seem to fix the problem. make cplan dir world
// writable. perhaps look in php.ini

// msg in feeder.log after touching reread_db:
/* 2011-01-21 04:22:25.4932  Found trigger file reread_db; re-scanning database tab */
/* les. */

// other instances of assigned result do not get assigned
// before other lower priority instances


////////////////////////////////////////////////////////////////////////
// Error handling



////////////////////////////////////////////////////////////////////////
// Tests completed by Derrick:

// Will not add redundant wus to assignment table.

// with min quorum of 1, cloud wus are completed first

// normal wu turned to assigned wu is completed successfully

// when asgn wu's are created via create_work, these are
// scheduled before the other workunits

// correctly touches reread_db

// prevent duplicate results of batch to be inserted into db

// high priority assigned tasks seem to be assigned before
// low priority ones

// test with multiple workers.

////////////////////////////////////////////////////////////////////////
// DEFINE
define("PROJECTDIR", "/home/boincadm/projects/clouds");
define("CLOUD_USER_ID", 1);

// maximum number of workunits to assign to cloud workers for a given
// batch.  Should be defined in relation to MAX_ASSIGNMENT in
// sched/sched_shmem.h and the number of workunits over all batches to be
// assigned to cloud workers.
define("MAX_TO_ASSIGN", 100);

////////////////////////////////////////////////////////////////////////

error_reporting(E_ALL);
ini_set('display_errors', true);
ini_set('display_startup_errors', true);

require_once("../inc/db.inc");
require_once("../inc/util_ops.inc");




db_init();


$batch = $_GET['batch'];


// defined doesn't seem to work either
if (!isset($batch)){
  echo 'ERROR: batch variable NOT set. Exiting... <br>';
  echo 'Usage: http://server/project_ops/assign_batch_to_cloud.php?batch=[id]<br>';
  echo 'Exiting...';
  exit(1);
}

echo 'batch: ' . $batch . '<br>';


$wus_in_batch = array();

// get all uncompleted workunits in batch

$sql = "select distinct(id) from workunit
WHERE canonical_resultid = 0 and batch = $batch limit " . MAX_TO_ASSIGN;

$result = mysql_query($sql);

if (!$result) {
    echo "Could not successfully run query ($sql) from DB: " . mysql_error();
    exit;
}



// get workunits already in the assignment table
$sql2 = "select distinct(workunitid) from assignment";

$result2 = mysql_query($sql2);

if (!$result2) {
    echo "Could not successfully run query ($sql2) from DB: " . mysql_error();
    exit;
}

echo 'Wus in assignment table:<br>';
while ( $row = mysql_fetch_array($result2)){
      $assignments[$row[0]] = $row[0];
      echo 'wu_id ' . $row[0] . '<br>';
}
echo '<br>';


// grab only those wu id's that do not already exist in the assignment table
$i=0;
echo 'Uncompleted wus:<br>';
while ( $row = mysql_fetch_array($result)){

  if (!isset($assignments) || !array_key_exists ($row[0], $assignments)){

      $wus_in_batch[$i] = $row[0];
      echo 'wu_id ' . $i . ': ' . $row[0] . '<br>';
      $i++;

  } else {
      echo '<span style="color:red"> wu_id ' . $i . ': ' . $row[0] . ' already exists</span><br>';

  }
}
echo '<br>';

// for each workunit in batch
//    add into assignment table the entry

$count = count($wus_in_batch);

echo 'Number of wus to add in asssignment table: ' . $count . '<br>';
echo '<br>';

for ($i=0; $i<$count; $i++){


  $id = 0;
  $create_time = time();
  $target_id = CLOUD_USER_ID;
  $target_type = 4; //cloud type
  $multi = 0;
  $workunitid = $wus_in_batch[$i];
  $resultid = 0;
  //result id of 0 should cause sched_assign to create a new
  //  result with id that is unique and autoincremented


  $query = "INSERT INTO assignment VALUES ($id,
  $create_time, $target_id, $target_type, $multi,
  $workunitid, $resultid)";

  echo $query . '<br>';

  $result = mysql_query($query);

}
sleep(2);

if ($count>0){
  // reset the feeder

  echo (exec('whoami') . "<br>");

  $cmd = "touch " . PROJECTDIR . "/reread_db";
  echo $cmd . '<br>';
  system($cmd);
/*   echo "$output[0]<br>"; */

}
?>
