#! /usr/bin/python


"""//Web service to administrate CreditSystem institutions//
 
- > This Web service can be use to register the institutions managed by the CreditSystem.
 
- File: admin_institutions.py

- Notes: 
 - A database configuration file named "db.cfg" must be present in the directory.

"""
import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
os.chdir(sys.path[0])
from tools import db_func
from tools import cgi_func
from tools import log_func
log=log_func.get_spequlos_log(__file__)

cgi_func.print_header()

if (cgi_func.get_form_value('Institution_Identity') is None) or (cgi_func.get_form_value('Available_Credits') is None):
    
    print "<p>Register a new institution (currently it must be an integer)</p>"
    cgi_func.print_form(['Institution_Identity','Available_Credits'])

    print "<p>Users already registered:</p><table border=1>"
    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("SELECT institution_id, credit_balance, credit_won, credit_spent FROM Institution")
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    res=c.fetchall()
    db_func.disconnect(conn)
    
    print "<tr><td>Institution</td><td>Credit Balance</td><td>Credit Won</td><td>Credit Spent</td></tr>" 
    for l in res:
        print "<tr>%s</tr>" % (" ".join(["<td>%s</td>" % r for r in l])) 
    print "</table><p>"

else:
    i_id = int(cgi_func.get_form_value('Institution_Identity'))
    credit = int(cgi_func.get_form_value('Available_Credits'))

    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("INSERT Institution(institution_id,credit_balance,credit_won,credit_spent,cloud_id) VALUES (%d,%d,%d,0,0)" % (i_id,credit,credit))
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    db_func.disconnect(conn)
    print "<p>Institution registered !</p>"
    print "<p> <a href='admin_institutions.py'>Go back</a></p>"

cgi_func.print_footer()

