#! /usr/bin/python


"""//Web service to administrate scheduler Cloud services//
 
- > This Web service can be use to register the Cloud services available to the scheduler.
 
- File: admin_cloud.py

- Notes: 
 - A database configuration file named "db.cfg" must be present in the directory.

"""
import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
os.chdir(sys.path[0])
from tools import db_func
from tools import cgi_func
from tools import log_func
log=log_func.get_spequlos_log(__file__)


if __name__=="__main__":

    db = db_func.SpeQuloS_DB(os.path.join(sys.path[0],"db.cfg"))        

    cgi_func.print_header()

    if cgi_func.get_form_value('del') != None:
        
        cloud_service_id = cgi_func.get_form_value('del')
        cgi_func.print_message("Deleting Cloud service %s" % cloud_service_id)

        db.sql_delete("CloudWorker","cloud_service_id='%s'" % cloud_service_id)        
        db.sql_delete("CloudService","cloud_service_id='%s'" % cloud_service_id)
        
        cgi_func.print_message("Cloud Service Deleted")
        cgi_func.print_message("<a href='admin_cloud.py'>Go back</a>")

    elif (cgi_func.get_form_value('Cloud_Service_Identifier') is None) \
    or  (cgi_func.get_form_value('Cloud_Service_Configuration_File') is None) \
    or  (cgi_func.get_form_value('Cloud_Service_Handler') is None) \
    or  (cgi_func.get_form_value('Number_Of_Instances') is None):
        
        cgi_func.print_message("Register a new Cloud service")
        cgi_func.print_form(['Cloud_Service_Identifier','Cloud_Service_Configuration_File','Number_Of_Instances'],{'Cloud_Service_Handler':["libcloud","command"]})


        cgi_func.print_message("Cloud service already registered:")
        cgi_func.print_raw("<table border=1>")
        cgi_func.print_raw("<tr><td>Cloud service Identifier</td><td>Cloud service Configuration File</td><td>Number Of Instances</td><td>Cloud service handler</td></tr>")

        for l in db.sql_select("CloudService",('cloud_service_id','cloud_service_conf_file','handler')):
            
            n_instances = len(db.sql_select("CloudWorker",('cloud_worker_id',),"cloud_service_id='%s'" % l['cloud_service_id']))
            cgi_func.print_raw("<tr><td>%s</td><td>%s</td><td>%d</td><td>%s</td><td><a href=admin_cloud.py?del=%s>Delete</a></td>" \
                % (l['cloud_service_id'],l['cloud_service_conf_file'],n_instances,l['handler'],l['cloud_service_id']) )

        cgi_func.print_raw("</table>")

    else:
        cloud_service_identifier = cgi_func.get_form_value('Cloud_Service_Identifier')
        cloud_service_configuration_file = cgi_func.get_form_value('Cloud_Service_Configuration_File')
        cloud_service_handler = cgi_func.get_form_value('Cloud_Service_Handler')
        
        try:
            n_instances = int(cgi_func.get_form_value('Number_Of_Instances'))
        except Exception as e:            
            cgi_func.print_message("Number_Of_Instances must be an integer")
            cgi_func.print_message("<a href='admin_cloud.py'>Go back</a>")
            sys.exit(1)
        for i in range(n_instances):
            db.sql_insert("CloudWorker",('cloud_service_id',),(cloud_service_identifier,))
            
        db.sql_insert("CloudService",('cloud_service_id','cloud_service_conf_file','handler'),(cloud_service_identifier,cloud_service_configuration_file,cloud_service_handler))

        print "<p> Cloud service registered !</p>"
        print "<p> <a href='admin_cloud.py'>Go back</a></p>"

    cgi_func.print_footer()

