#! /usr/bin/python


"""//Web service to administrate scheduler Desktop Grids//
 
- > This Web service can be use to register Desktop Grids connected to the scheduler.
 
- File: admin_dg.py

- Notes: 
 - A database configuration file named "db.cfg" must be present in the directory.

"""
import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
os.chdir(sys.path[0])
from tools import db_func
from tools import cgi_func
from tools import log_func
log=log_func.get_spequlos_log(__file__)


if __name__=="__main__":

    db = db_func.SpeQuloS_DB(os.path.join(sys.path[0],"db.cfg"))        

    cgi_func.print_header()

    if cgi_func.get_form_value('del') != None:
        dg_id = cgi_func.get_form_value('del')
        cgi_func.print_message("Deleting desktop grid %s" % dg_id)
        
        db.sql_delete("DesktopGrid","dg_id='%s'" % dg_id)
        
        cgi_func.print_message("Desktop Grid Deleted")
        cgi_func.print_message("<a href='admin_dg.py'>Go back</a>")

    elif (cgi_func.get_form_value('Desktop_Grid_Identifier') is None) or  (cgi_func.get_form_value('Desktop_Grid_Configuration_File') is None):
        
        cgi_func.print_message("Register a new desktop grid")
        cgi_func.print_form(['Desktop_Grid_Identifier','Desktop_Grid_Configuration_File'])

        cgi_func.print_message("Desktop Grid already registered:")
        cgi_func.print_raw("<table border=1>")
        cgi_func.print_raw("<tr><td>Desktop Grid Identifier</td><td>Desktop Grid Configuration File</td></tr>")

        for l in db.sql_select("DesktopGrid",('dg_id','dg_conf_file')):
            print "<tr><td>%s</td><td>%s</td><td><a href=admin_dg.py?del=%s>Delete</a></td>" \
                % (l['dg_id'],l['dg_conf_file'],l['dg_id']) 

        cgi_func.print_raw("</table>")

    else:
        dg_identifier = cgi_func.get_form_value('Desktop_Grid_Identifier')
        dg_configuration_file = cgi_func.get_form_value('Desktop_Grid_Configuration_File')

        db.sql_insert("DesktopGrid",('dg_id','dg_conf_file'),(dg_identifier,dg_configuration_file))

        print "<p> Desktop Grid registered !</p>"
        print "<p> <a href='admin_dg.py'>Go back</a></p>"

    cgi_func.print_footer()

