#! /usr/bin/python

"""//Module for reading configuration files//

- File: conf_func.py

""" 

import log_func
log=log_func.get_spequlos_log(__file__)


def read_config(filename):
    """//Read a configuration file//
    
    - > This readers parse a configuration with pattern ``option=value`` on multiple lines.     
    - Lines starting with # or ; are ignored
    
    - Arguments:
     - filename --- The configuration file name, as a string
    
    - The function returns a dictionnary containing the set of strings' (option,values) as read in the file
    
    """ 
    params={}
    
    if not isinstance(filename,str):
        log.error("The filename argument must be a string !")
        return params    
    try:
        f = open(filename)
    except IOError as e:
        log.error("Error when opening file: %s" % filename)
        log.error(e)
    else:
        splitchar = "=" 
        for l in f:
            param_line=l.strip().split(splitchar)
            if len(param_line)>=2 and len(param_line[0])>0 and len(param_line[1])>0:
                if param_line[0][0]!="#" and param_line[0][0]!=";":
                    p=splitchar.join(param_line[1:])
                    #Deleting quote enclosure
                    while p[0]==p[-1] and p[0] in ("'",'"'," "):
                        p=p[1:-1]
                    p.strip()
                    params[param_line[0]]=p
        f.close()                 
    return params

if __name__ == "__main__":
    import sys
    params=read_config(sys.argv[1])
    for p in params:
        print p,params[p]
